/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.search.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.search.entity.BenutzerSuchparameter;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractBenutzerSuchparameterSearch {

  @Inject
  protected transient BenutzerSuchparameterExtendedDAO dao;

  public AbstractBenutzerSuchparameterSearch() {
    super();
  }

  public List<BenutzerSuchparameter> getSearchResult(BenutzerSuchparameterSearchParameters searchParameters, EagerLoadingCollector<BenutzerSuchparameter> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<BenutzerSuchparameter> querySearchResult(BenutzerSuchparameterSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
